LeetCode: 2207. 字符串中最多数目的子序列 一次遍历数组,时间复杂度O(n)

2207. 字符串中最多数目的子序列

today 2207 字符串中最多数目的子序列

题目描述

你一个下标从 0 开始的字符串 text 和另一个下标从 0 开始且长度为 2 的字符串 pattern ,两者都只包含小写英文字母。

你可以在 text 中任意位置插入 一个 字符,这个插入的字符必须是 pattern[0] 或者 pattern[1] 。注意,这个字符可以插入在 text 开头或者结尾的位置。

请你返回插入一个字符后,text 中最多包含多少个等于 pattern 的 子序列 。

子序列 指的是将一个字符串删除若干个字符后(也可以不删除),剩余字符保持原本顺序得到的字符串。

示例 1:

输入:text = "abdcdbc", pattern = "ac"

输出:4

解释:

如果我们在 text1 和 text2 之间添加 pattern0 = 'a' ,那么我们得到 "abadcdbc" 。那么 "ac" 作为子序列出现 4 次。

其他得到 4 个 "ac" 子序列的方案还有 "aabdcdbc" 和 "abdacdbc" 。

但是,"abdcadbc" ,"abdccdbc" 和 "abdcdbcc" 这些字符串虽然是可行的插入方案,但是只出现了 3 次 "ac" 子序列,所以不是最优解。

可以证明插入一个字符后,无法得到超过 4 个 "ac" 子序列。
示例 2:

输入:text = "aabb", pattern = "ab"

输出:6

解释:

可以得到 6 个 "ab" 子序列的部分方案为 "aaabb" ,"aaabb" 和 "aabbb" 。

提示:
1 <= text.length <= 105
pattern.length == 2
text 和 pattern 都只包含小写英文字母。

解题思路

这道题目是一道字符串匹配问题,我们可以遍历 text,使用 first_count 来记录已经遇到的 pattern[0] 的个数。每当遇到 pattern[1] 时,所有之前遇到的 pattern[0] 都可以和当前的 pattern[1] 组成一个子序列,所以每次遇到 pattern[1] 时,更新子序列计数。
res 表示目前已经形成的 pattern 子序列个数。

之后,为了最大化子序列数量,我们可以:

  • 在 text 的开头插入一个 pattern0,这样每个 pattern1 都可以与之构成一个新的子序列,增加 second_count 个子序列。
  • 在 text 的结尾插入一个 pattern1,这样每个 pattern0 都可以与之构成一个新的子序列,增加 first_count 个子序列。

res=max(second_count,first_count)+res

最后,我们返回 res。

复杂度分析:

  • 时间复杂度: O ( n ) O(n) O(n),其中 n 是 text 的长度。
  • 空间复杂度: O ( 1 ) O(1) O(1),只使用常数的额外空间。

代码实现

Python实现:

python 复制代码
class Solution(object):
    def maximumSubsequenceCount(self, text, pattern):
        firstNum=0
        secondNum=0
        first=pattern[0]
        second=pattern[1]
        res=0
        for i in text:
            if i==second:
                secondNum+=1
                res+=firstNum
            if i==first:
                firstNum+=1

                
        return res + max(firstNum, secondNum)

Go实现:

go 复制代码
func maximumSubsequenceCount(text string, pattern string) int64 {
    var res int64
    firstCount, secondCount := int64(0), int64(0)
    first := pattern[0]
    second := pattern[1]

    // 遍历text,统计符合pattern[0]开头,pattern[1]结尾的子序列个数
    for _, char := range text {
        if byte(char) == second {
            // 每遇到一个pattern[1]字符,所有之前的pattern[0]字符都可以与之形成一个子序列
            res += firstCount
            secondCount++
        }
        if byte(char) == first {
            // 统计pattern[0]字符的出现次数
            firstCount++
        }
    }

    // 结果是原始子序列加上插入后的最大值
    return res + max(firstCount, secondCount)
}
相关推荐
tellmewhoisi14 分钟前
深度学习0:数学知识:正态分布1
人工智能·深度学习·算法
-梅16 分钟前
算法(1) 动态规划
算法·动态规划
青少儿编程课堂34 分钟前
蓝桥杯·全国青少年信息素养大赛·电子学会Python/C++考级:Bellman-Ford与SPFA含负权最短路及负环检测全解析
c++·python·算法·bfs·信息学竞赛
文丑颜不良啊1 小时前
LeetCode2061~2080题目解析
java·leetcode
octopus_c2 小时前
STL 之 string:auto 与范围 for、常用接口、模拟实现与深浅拷贝
开发语言·c++·算法
文丑颜不良啊13 小时前
LeetCode1941~1960题目解析
java·leetcode
MUSHANGXS15 小时前
大模型时代的新蓝海-基于OS底层的AI-Agent应用
人工智能·职场和发展·交互
老师我太想进步了202617 小时前
【数据结构-4】算法美学之顺序表
数据结构·算法
风影同志7832417 小时前
编码器是激活函数吗?—— 一个看起来很像、其实不是的类比
算法
UIU11417 小时前
P1481 魔族密码
c++·算法·动态规划